/* Generate coff file
   Copyright 2002-2005	Craig Franklin
*/

#pragma once

#define SECTION_FLAGS state.obj.flags
#define IS_RAM_ORG    (SECTION_FLAGS & STYP_RAM_AREA)

void coff_init(void);
extern void coff_cleanup_before_eof(void);
void coff_close_file(void);
void coff_new_section(const char *Name, unsigned Byte_addr, unsigned Flags);
void coff_close_section(void);

gp_symbol_t* coff_add_sym(const char *Name, gpasmVal Value, enum gpasmValTypes Type,
                                 int Section_number);

extern void coff_add_reloc(unsigned Symbol_number, int Offset, uint16_t Type);
void coff_add_linenum(unsigned Emitted);
gp_symbol_t* coff_add_file_sym(const char *File_name, bool Is_include);
void coff_add_eof_sym(void);
void coff_add_list_sym(const char*name=".list");
inline void coff_add_nolist_sym() {coff_add_list_sym(".nolist");}
void coff_add_direct_sym(uint8_t Command, const char *String);
void coff_add_ident_sym(const char *String);
char *coff_local_name(const char *Name);

